using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Odbc;
using System.Data;

/*
 * Demo 2
 * 
 * Slightly more sophisticated select statement.
 * Uses parameterized arguments. 
 * Uses column name to refer to columns in reader result.
 */

namespace B_ParameterizedArguments
{
    class ParameterizedArguments
    {
        static string connectionString = "DRIVER={MySQL ODBC 3.51 Driver};"+
            "SERVER=oberon.cs.wisc.edu;PORT=3400;"+
            "DATABASE=CS369_0;USER=CS369_0;PASSWORD=26351;OPTION=3;";
        // Change to an invalid database name or user name to see an exception being thrown

        static void Main(string[] args)
        {
            OdbcConnection connection = new OdbcConnection(connectionString);
            OdbcCommand command = new OdbcCommand();
            OdbcDataReader reader = null;

            command.Connection = connection;
            command.CommandText = "select lastname,firstname from people where state like ? order by lastname;";
            command.Parameters.AddWithValue("@state", "NJ");
            // command.Parameters.AddWithValue("cheeseburgerandmilkshake", "NJ"); //Works the same

            try
            {
                connection.Open();

                reader = command.ExecuteReader();

                while (reader.Read())
                {
                    Console.WriteLine(string.Format("{0}, {1}", reader["lastname"].ToString(), reader["firstname"].ToString()));
                }
            }
            catch (Exception e)
            {
                Console.Error.WriteLine(e.Message);
            }
            finally
            {
                if (reader != null && !reader.IsClosed)
                    reader.Close();
                if (connection.State == ConnectionState.Open)
                    connection.Close();
            }

            Console.WriteLine("Hit return to exit.");
            Console.Read();
        }
    }
}
