using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.Odbc;

/*
 * Uses a join to compute a complex result. Gets the number of grades for each course and 
 * print these along with the catalog number and name of each course. The number of grades
 * for each course comes from grades. The two tables are joined on the course ID found in
 * both tables.
 * 
 */


namespace E_OneJoin
{
    class OneJoin
    {
        static string connectionString = "DRIVER={MySQL ODBC 3.51 Driver};" +
            "SERVER=oberon.cs.wisc.edu;PORT=3400;" +
            "DATABASE=CS369_0;USER=CS369_0;PASSWORD=26351;OPTION=3;";

        static void Main(string[] args)
        {
            OdbcConnection connection = new OdbcConnection(connectionString);
            OdbcCommand command = new OdbcCommand();
            OdbcDataReader reader = null;

            command.Connection = connection;
            command.CommandText = "select catalognumber,name,count(courseid) from courses,grades where id = courseid group by catalognumber order by catalognumber;";

            try
            {
                connection.Open();

                reader = command.ExecuteReader();

                while (reader.Read())
                {
                    Console.WriteLine(string.Format("{0} {1} {2}", reader[0].ToString(), reader[1].ToString(), reader[2].ToString()));
                }
            }
            catch (Exception e)
            {
                Console.Error.WriteLine(e.Message);
            }
            finally
            {
                if (reader != null && !reader.IsClosed)
                    reader.Close();
                if (connection.State == ConnectionState.Open)
                    connection.Close();
            }

            Console.WriteLine("Hit return to exit.");
            Console.Read();
        }
    }
}
