using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.Odbc;

/*
 * Joins three tables. Prints a grade report for all students from NJ.
 * 
 */

namespace F_TwoJoins
{
    class TwoJoins
    {
        static string connectionString = "DRIVER={MySQL ODBC 3.51 Driver};" +
            "SERVER=oberon.cs.wisc.edu;PORT=3400;" +
            "DATABASE=CS369_0;USER=CS369_0;PASSWORD=26351;OPTION=3;";

        static void Main(string[] args)
        {
            OdbcConnection connection = new OdbcConnection(connectionString);
            OdbcCommand command = new OdbcCommand();
            OdbcDataReader reader = null;

            command.Connection = connection;
            command.CommandText = "select lastname,firstname,catalognumber,grade,semester,year from people,grades,courses where people.id = grades.studentid and grades.courseid = courses.id and state like ? group by lastname,catalognumber;";
            command.Parameters.AddWithValue("@state", "NJ");

            try
            {
                connection.Open();

                reader = command.ExecuteReader();

                while (reader.Read())
                {
                    Console.WriteLine(string.Format("{0} {1} {2} {3} {4} {5}", reader[0].ToString(), reader[1].ToString(), reader[2].ToString(), reader[3].ToString(), reader[4].ToString(), reader[5].ToString()));
                }
            }
            catch (Exception e)
            {
                Console.Error.WriteLine(e.Message);
            }
            finally
            {
                if (reader != null && !reader.IsClosed)
                    reader.Close();
                if (connection.State == ConnectionState.Open)
                    connection.Close();
            }

            Console.WriteLine("Hit return to exit.");
            Console.Read();
        }
    }
}

