using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.Odbc;

/*
 * For all students from Wisconsin updates the city to Madison and the street to Dayton.
 * 
 */

namespace G_UpdateExample
{
    class UpdateExample
    {
        static string connectionString = "DRIVER={MySQL ODBC 3.51 Driver};" +
            "SERVER=oberon.cs.wisc.edu;PORT=3400;" +
            "DATABASE=CS369_0;USER=CS369_0;PASSWORD=26351;OPTION=3;";

        static void Main(string[] args)
        {
            OdbcConnection connection = new OdbcConnection(connectionString);
            OdbcCommand command = new OdbcCommand();
            OdbcDataReader reader = null;

            command.Connection = connection;
            command.CommandText = "select lastname,firstname,city,street from people where state like ? order by lastname;";
            command.Parameters.AddWithValue("@state", "wi");
            try
            {
                connection.Open();

                reader = command.ExecuteReader();

                Console.WriteLine("Old data");
                while (reader.Read())
                {
                    Console.WriteLine("{0:15}, {1:15} -- {2:15}, {3:15}", reader["lastname"], reader["firstname"], reader["street"], reader["city"]);
                }
                reader.Close();

                command = new OdbcCommand();
                command.Connection = connection;
                command.CommandText = "update people set street=? , city=? where state=? ;";
                command.Parameters.AddWithValue("", "Dayton");
                command.Parameters.AddWithValue("", "Madison");
                command.Parameters.AddWithValue("", "wi");
                command.ExecuteNonQuery();

                command = new OdbcCommand();
                command.Connection = connection;
                command.CommandText = "select lastname,firstname,city,street from people where state like ? order by lastname;";
                command.Parameters.AddWithValue("@state", "wi");
                reader = command.ExecuteReader();

                Console.WriteLine("New data");
                while (reader.Read())
                {
                    Console.WriteLine("{0:15}, {1:15} -- {2:15}, {3:15}", reader["lastname"], reader["firstname"], reader["street"], reader["city"]);
                }
            }
            catch (Exception e)
            {
                Console.Error.WriteLine(e.Message);
            }
            finally
            {
                if (reader != null && !reader.IsClosed)
                    reader.Close();
                if (connection.State == ConnectionState.Open)
                    connection.Close();
            }
            Console.WriteLine("Hit return to exit.");
            Console.Read();
        }
    }
}
